//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using Tecan.Sila2;


namespace Tecan.Sila2.Interop.Server.MetadataConsumerTest
{
    
    
    /// <summary>
    /// Data transfer object for the request of the Echo String Metadata command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoStringMetadataRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoStringMetadataRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public EchoStringMetadataRequestDto(Tecan.Sila2.IBinaryStore store)
        {
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/test/MetadataConsumerTest/v1/Command/EchoStringMetadata";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return null;
        }
    }
    
    /// <summary>
    /// Data transfer object for the response of the Echo String Metadata command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoStringMetadataResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private Tecan.Sila2.StringDto _receivedStringMetadata;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoStringMetadataResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="receivedStringMetadata">The received string metadata</param>
        public EchoStringMetadataResponseDto(string receivedStringMetadata, Tecan.Sila2.IBinaryStore store)
        {
            ReceivedStringMetadata = new Tecan.Sila2.StringDto(receivedStringMetadata, store);
        }
        
        /// <summary>
        /// The received string metadata
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto ReceivedStringMetadata
        {
            get
            {
                return _receivedStringMetadata;
            }
            set
            {
                _receivedStringMetadata = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(ReceivedStringMetadata, "receivedStringMetadata");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(ReceivedStringMetadata, "receivedStringMetadata"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the request of the Echo String And Structure Metadata command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class UnpackMetadataRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public UnpackMetadataRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public UnpackMetadataRequestDto(Tecan.Sila2.IBinaryStore store)
        {
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/test/MetadataConsumerTest/v1/Command/UnpackMetadata";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return null;
        }
    }
    
    /// <summary>
    /// Data transfer object for the response of the Echo String And Structure Metadata command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class UnpackMetadataResponseDto : Tecan.Sila2.ISilaTransferObject<UnpackMetadataResponse>
    {
        
        private Tecan.Sila2.StringDto _receivedString;
        
        private Tecan.Sila2.IntegerDto _firstReceivedInteger;
        
        private Tecan.Sila2.IntegerDto _secondReceivedInteger;
        
        /// <summary>
        /// Initializes a new instance (to be used by the serializer)
        /// </summary>
        public UnpackMetadataResponseDto()
        {
        }
        
        /// <summary>
        /// Initializes a new data transfer object from the business object
        /// </summary>
        /// <param name="inner">The business object that should be transferred</param>
        /// <param name="store">A component to handle binary data</param>
        public UnpackMetadataResponseDto(UnpackMetadataResponse inner, Tecan.Sila2.IBinaryStore store)
        {
            ReceivedString = new Tecan.Sila2.StringDto(inner.ReceivedString, store);
            FirstReceivedInteger = new Tecan.Sila2.IntegerDto(inner.FirstReceivedInteger, store);
            SecondReceivedInteger = new Tecan.Sila2.IntegerDto(inner.SecondReceivedInteger, store);
        }
        
        /// <summary>
        /// The received string (via "String Metadata")
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto ReceivedString
        {
            get
            {
                return _receivedString;
            }
            set
            {
                _receivedString = value;
            }
        }
        
        /// <summary>
        /// The first element of the received integer structure (via "Two Integers Metadata")
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(2)]
        public Tecan.Sila2.IntegerDto FirstReceivedInteger
        {
            get
            {
                return _firstReceivedInteger;
            }
            set
            {
                _firstReceivedInteger = value;
            }
        }
        
        /// <summary>
        /// The second element of the received integer structure (via "Two Integers Metadata")
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(3)]
        public Tecan.Sila2.IntegerDto SecondReceivedInteger
        {
            get
            {
                return _secondReceivedInteger;
            }
            set
            {
                _secondReceivedInteger = value;
            }
        }
        
        /// <summary>
        /// Extracts the transferred value
        /// </summary>
        /// <param name="store">The binary store in which to store binary data</param>
        /// <returns>the inner value</returns>
        public UnpackMetadataResponse Extract(Tecan.Sila2.IBinaryStore store)
        {
            return new UnpackMetadataResponse(ReceivedString.Extract(store), FirstReceivedInteger.Extract(store), SecondReceivedInteger.Extract(store));
        }
        
        /// <summary>
        /// Creates the data transfer object from the given object to transport
        /// </summary>
        /// <param name="inner">The object to transfer</param>
        /// <param name="store">An object to store binary data</param>
        public static UnpackMetadataResponseDto Create(UnpackMetadataResponse inner, Tecan.Sila2.IBinaryStore store)
        {
            return new UnpackMetadataResponseDto(inner, store);
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ((("" + Argument.Require(ReceivedString, "receivedString")) 
                        + Argument.Require(FirstReceivedInteger, "firstReceivedInteger")) 
                        + Argument.Require(SecondReceivedInteger, "secondReceivedInteger"));
        }
    }
}
